import * as t from '@babel/types';
import { NodePath } from '@babel/traverse';
declare type DeclarationKind = 'var' | 'let' | 'const';
/**
 * Determines the most restrictive declaration kind for a variable declaration.
 * `const` is preferred, followed by `let` if one or more bindings are
 * reassigned, then `var` if block scoping cannot be used.
 */
export default function mostRestrictiveKindForDeclaration(path: NodePath<t.VariableDeclaration>): DeclarationKind;
export {};
